import java.util.ArrayList;

/**********************************************************************************************************************

 AUFGABENBLATT 7 für alle Übungsgruppen - Allgemeine Informationen

 Das Projekt Aufgabenblatt7 besteht aus fünf Aufgaben in den Klassen Aufgabe1 bis Aufgabe5, die Sie erweitern und in
 den Übungen vom 15.6. bis 19.6. präsentieren müssen.

 Die Beantwortung von Fragen, die mit [fortgeschritten] gekennzeichnet sind, ist für fortgeschrittene Gruppen
 *verpflichtend*. Für andere Teilnehmer sind diese Fragen (obwohl empfohlen) freiwillig. Sind Sie in einer
 fortgeschrittenen Gruppe werden Kreuzerl, in denen [fortgeschritten] nicht berücksichtigt wurde, aberkannt.

 Achten Sie bei der Implementierung von Aufgabe1 bis Aufgabe5 auf folgende Punkte:

 - Ändern Sie nur die Ordner tasks in Aufgabe1 bis Aufgabe5, lassen Sie alle anderen Ordner (insbesondere tests)
 des Projekts unverändert. Wenn notwendig, können Sie neue Klassen erstellen.
 - Ihr Programm sollte den dazugehörenden Test (z.B. enthält Aufgabe1Test den Test zu Aufgabe1) bestehen.
 - Sie dürfen den Test zu einer Aufgabe nicht (!) verändern, da Sie sonst beim Übersetzen falsche Meldungen bekommen.
 - Bei jeder Aufgabe finden Sie Zusatzfragen. Diese Zusatzfragen beziehen sich thematisch auf das erstellte Programm.
 Sie müssen diese Zusatzfragen in der Übung beantworten können.
 - Verwenden Sie zur Ausgabe immer System.out.println().
 - Verwenden Sie keine speziellen Aufrufe aus der Java-API, die die Aufgaben vereinfachen würden.

 Abgabe:  Die Abgabe muss bis Sonntag, den 14.6. um 13:59 erfolgen. Alle Änderungen am Projekt in der
 Übungsumgebung, die bis zu diesem Zeitpunkt von Ihnen vorgenommen wurden, werden als Abgabe betrachtet.

 ***********************************************************************************************************************/

/*
    Aufgabe1) toString, equals, hashCode implementieren

    Beschreibung

    Implementieren Sie die Klasse Person mit folgenden Eigenschaften:

    - Vorname
    - Nachname
    - Geschlecht
    - Alter (als Zahl)
    - Sozialversicherungsnummer (als vierstellige Zahl)
    - Liste aller Kinder dieser Person (Es kann beliebig viele Kinder,
      aber auch gar kein Kind geben)

    Abgesehen von der Liste der Kinder sollen alle Eigenschaften im
    Konstruktor festgelegt werden.

    Vermeiden Sie unnötige "setter"-Methoden!

    Um ein Kind hinzufügen zu können, implementieren Sie die Methode:

      void neuesKind(Person p);

    Stellen Sie sicher, dass die Ausgabe eines Objekts vom Typ Person
    mittels System.out.println(person) folgende Beschreibung dieser Person
    liefert:

    # <Vorname> <Nachname>, <Geschlecht>, <Alter> Jahre, Svnr: <Sozialversicherungsnummer>

    Hat eine Person Kinder, so werden auch rekursiv alle Kinder dieser
    Person (sowie auch alle darunterliegenden Hierarchieebenen) bei der
    Ausgabe berücksichtigt. Jede Ebene wird mit einem Leerzeichen
    eingerückt, z.B:

    # <Vorname> <Nachname>, <Geschlecht>, <Alter> Jahre, Svnr: <Sozialversicherungsnummer>
     # <Vorname Kind1> <Nachname Kind1>, <Geschlecht Kind1>, <Alter Kind1> Jahre, Svnr: <Sozialversicherungsnummer Kind1>
     # <Vorname Kind2> <Nachname Kind2>, <Geschlecht Kind2>, <Alter Kind2> Jahre, Svnr: <Sozialversicherungsnummer Kind2>
      # <Vorname Kind1 von Kind2> <Nachname Kind1 von Kind2>, <Geschlecht Kind1 von Kind2>, <Alter Kind1 von Kind2> Jahre, Svnr: <Sozialversicherungsnummer Kind1 von Kind2>

    Implementieren Sie createHubert() so, dass die zurückgelieferte Person
    folgende Ausgabe hat:

    # Hubert Maier, maennlich, 88 Jahre, Svnr: 1234
     # Julia Maier, weiblich, 54 Jahre, Svnr: 1111
      # Thomas Maier, maennlich, 22 Jahre, Svnr: 2222
      # Gernot Maier, maennlich, 24 Jahre, Svnr: 3333
     # Gernot Mueller, maennlich, 40 Jahre, Svnr: 1115
      # Roman Mueller, maennlich, 12 Jahre, Svnr: 1116
      # Sophie Mueller, weiblich, 14 Jahre, Svnr: 1117

    createJulia() soll innerhalb von createHubert() verwendet werden
    und createThomas() innerhalb von createJulia(). Es dürfen weitere
    Hilfsmethoden verwendet werden, diese werden aber nicht in den
    Testfällen verwendet.

    Innerhalb der Liste der Kinder einer Person, darf es keine zwei
    gleichen Objekte vom Typ Person geben. Zwei Personen sind gleich, wenn
    ihr Vor- und Nachname, sowie ihre Sozialversicherungsnummer gleich ist.

    Achten Sie auch darauf, dass hashCode() korrekt funktioniert und alle Modifier korrekt sind.

    Kommentieren Sie Ihr Programm ausreichend!

    [fortgeschritten]
    Person soll keine Klasse sondern ein Interface sein.
    Die implementierende Klasse können Sie beliebig benennen.
    Passen Sie auch die Methoden Aufgabe1.create<Person>() entsprechend an.
    Stellen Sie außerdem sicher, dass Kinder jünger als Eltern sind und das
    auch andere ungültigen Werte abgewiesen werden (Alter<0, Svnr<0 oder > 9999).
    Kommentieren Sie auch entsprechend wie sich Ihr Programm verhält.
    Überlegen Sie sich, welche Methoden statt "setter"-Methoden sinnvoll wären.

    Zusatzfragen:
    1. Wie verhält sich das Programm wenn es keine eigene Implementierung
       von equals gibt?
    2. Warum sollte man zur textuellen Beschreibung einer Klasse toString
       verwenden und keine Methode mit einem anderen Namen implementieren?
    3. Warum wird hashCode benötigt und wie kann der Rückgabewert dieser
       Methode interpretiert werden?
    4. Warum eignet sich hashCode() nicht für Vergleiche von Objekten?
    5. Inwiefern können Namen und Kommentare altern?
*/

class Personen implements Person{
    String vorname;
    String nachname;
    String geschlecht;
    int alter;
    int sozialversicherungsnr;
    ArrayList<Person> kinder = new ArrayList<Person>();
    static int count;

    public Personen(String vn, String nn, String g, int a, int svnr){
        this.vorname = vn;
        this.nachname = nn;
        this.geschlecht = g;
        this.alter = a;
        this.sozialversicherungsnr = svnr;
        this.count = 0;
    }
    @Override
    public void neuesKind(Person p) {
        if(p == null || p.equals(this)){
            return;
        }
        //Fortgeschritten: check des Alters
        if(p.getAge() >= this.getAge()){
            return;
        }

        for(Person k : kinder){
            if(k.equals(p)){
                return;
            }
        }

        kinder.add(p);
    }
    @Override
    public int getSsn() {
        return this.sozialversicherungsnr;
    }
    @Override
    public int getAge() {
        return this.alter;
    }

    @Override
    public boolean isMale() {
        return this.geschlecht.equals("maennlich");
    }
    @Override
    public String getSurname() {
        return this.nachname;
    }
    @Override
    public String getFirstname() {
        return this.vorname;
    }

    public String toString() {
        String result="";

        for(int i=0; i<count; i++){
            result += " ";
        }
        result += "# "+this.vorname+" "+this.nachname+", "+this.geschlecht+", "+this.alter+" Jahre, Svnr: "+this.sozialversicherungsnr;
        for(Person p: kinder){
            count++;
            result += "\n"+p.toString();
        }
        if(count > 0) {
            count--;
        }
        return result;
    }

    @Override
    public int hashCode() {
        int result = kinder != null ? kinder.hashCode() : 0;
        result = 31 * result + (vorname != null ? vorname.hashCode() : 0);
        result = 31 * result + (nachname != null ? nachname.hashCode() : 0);
        result = 31 * result + (geschlecht != null ? geschlecht.hashCode() : 0);
        result = 31 * result + alter;
        result = 31 * result + sozialversicherungsnr;
        return result;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }

        Personen per = (Personen) o;

        if (sozialversicherungsnr != per.sozialversicherungsnr) {
            return false;
        }
        if (vorname != null ? !vorname.equals(per.vorname) : per.vorname != null) {
            return false;
        }
        if (nachname != null ? !nachname.equals(per.nachname) : per.nachname != null) {
            return false;
        }
        return true;
    }
}

public class Aufgabe1 {
    // just for testing ...
    public static void main(String[] args) {
        // Implementierung von main wird nicht beurteilt

        /*String example = "# Hubert Maier, maennlich, 88 Jahre, Svnr: 1234\n" +
                " # Julia Maier, weiblich, 54 Jahre, Svnr: 1111\n" +
                "  # Thomas Maier, maennlich, 22 Jahre, Svnr: 2222\n" +
                "  # Gernot Maier, maennlich, 24 Jahre, Svnr: 3333\n" +
                " # Gernot Mueller, maennlich, 40 Jahre, Svnr: 1115\n" +
                "  # Roman Mueller, maennlich, 12 Jahre, Svnr: 1116\n" +
                "  # Sophie Mueller, weiblich, 14 Jahre, Svnr: 1117";


        Person hubert = Aufgabe1.createHubert();
        Person julia = Aufgabe1.createJulia();
        Person thomas = Aufgabe1.createThomas();

        Person hubert2 = Aufgabe1.createHubert();
        Person julia2 = Aufgabe1.createJulia();
        Person thomas2 = Aufgabe1.createThomas();

        // should not modify hubert
        hubert.neuesKind(julia);
        System.out.println(hubert.toString().equals(example));
        hubert.neuesKind(julia2);
        System.out.println(hubert.toString());
        System.out.println(example);
        System.out.println(hubert.toString().equals(example));
        System.out.println(hubert.equals(hubert2));*/
    }

    public static Person createHubert() {
        /* TODO: add code here */
        Person hubert = new Personen("Hubert","Maier", "maennlich", 88, 1234);
        hubert.neuesKind(createJulia());

        hubert.neuesKind(setChildren());

        return hubert;
    }

    public static Person createJulia(){
        /* TODO: add code here */
        Person julia = new Personen("Julia","Maier", "weiblich", 54, 1111);
        julia.neuesKind(createThomas());

        Person gernot = new Personen( "Gernot", "Maier", "maennlich", 24,3333);
        julia.neuesKind(gernot);

        return julia;
    }

    public static Person createThomas() {
        /* TODO: add code here */
        Person thomas = new Personen("Thomas", "Maier", "maennlich", 22, 2222);

        return thomas;
    }

    /**
     * erstellt eine neue Person
     * Stimmen die Personendaten nicht überein, wird eine IllegalArgumentException geworfen.
     */
    public static Person createPerson(String vorname, String nachname, String geschlecht, int alter, int svn) throws IllegalArgumentException{
        if(alter < 0 || svn < 0 || svn > 9999){
            throw new IllegalArgumentException("Alter/SotialversicherungNr < 0 oder SozialversicherungsNr > 9999");
        }
        Person p = new Personen(vorname, nachname, geschlecht, alter, svn);
        return p;
    }

    /**
     * Hilfsmethode
     */
    private static Person setChildren(){
        Person gernot = new Personen("Gernot", "Mueller", "maennlich", 40, 1115);
        Person roman  = new Personen( "Roman", "Mueller", "maennlich", 12 , 1116);
        Person sophie = new Personen( "Sophie", "Mueller", "weiblich", 14 , 1117);

        gernot.neuesKind(roman);
        gernot.neuesKind(sophie);
        return gernot;
    }

}
