import java.util.ArrayList;

public class Veranstaltung {
    int performances;
    private ArrayList<Kuenstler> teilnehmer = new ArrayList<Kuenstler>();
    public ArrayList<Vote> votes = new ArrayList<Vote>();

    //Hilfsklasse: Votes werden hier gespeichert
    private class Vote {
        Kuenstler voter, voted;
        String scoreString;

        Vote(Kuenstler v, Kuenstler k, String scoreString) {
            this.voter = v;
            this.voted = k;
            this.scoreString = scoreString;
        }

        //Anzahl bewerteter performances
        int size(){
            int result = 0;

            for (int i = 0; i < scoreString.length(); i++) {
                if (scoreString.charAt(i) == ':')
                    result++;
            }
            return result;
        }

        String getVoted() {
            return this.voted.getName();
        }
        String getVoter() {
            return this.voter.getName();
        }

        //berechnet Punkte von Vote
        double getPoints() {
            double result = 0.0;
            String temp = "";
            for (int i = 0; i < this.scoreString.length(); i++) {
                if (this.scoreString.charAt(i) == ':') {
                    for (int j = 1; this.scoreString.charAt(i+j) != '%'; j++) {
                        temp += this.scoreString.charAt(i+j);
                    }
                    result += (Double.parseDouble(temp) / 100) * 5;
                    temp = "";
                }
            }
            return result;
        }
    }


    public Veranstaltung(int performances) {
        this.performances = performances;
    }

    double points(Kuenstler k) throws InvalidCandidateException {
		/* TODO: add code here */
        double result = 0.0;
        for (Vote elem : votes) {
            if (elem.voted.getName().equals(k.getName())) {
                result += elem.getPoints();
            }
        }
        System.err.println(k.getName() + " hat " + result + " Punkte.");
        return result;
    }

    void teilnehmen(Kuenstler k) throws InvalidCandidateException {
		/* TODO: add code here */
        //keine teilnehmer oder teilnehmer bereits vorhanden
        if (this.teilnehmer == null || !this.teilnehmer.contains(k)) {
            this.teilnehmer.add(k);
        } else {
            throw new InvalidCandidateException();
        }
    }

    void vote (Kuenstler v, Kuenstler k, String scoreString) throws InvalidVoteException, InvalidCandidateException {
    	/* TODO: add code here */
        /*

        2. Ein Künstler darf pro Veranstaltung maximal 3 Votes vergeben.


         */

        /*
            1. Ein Künstler darf nur anderen Künstlern, die am Wettbewerb
                teilnehmen Votes geben. Ein Künstler muss aber nicht selbst am Wettbewerb
                teilnehmen, um Votes vergeben zu dürfen.
         */
        if (!teilnehmer.contains(k)) {
            throw new InvalidCandidateException();
        }
        /*
            3. Ein Künstler darf nur ein Mal für einen anderen Künstler voten, der am
                Wettbewerb teilnimmt.
         */
        for (Vote temp : votes) {
            if (v.getName().equals(temp.getVoter()) && k.getName().equals(temp.getVoted())) {
                throw new InvalidVoteException();
            }
        }
        /*
            4. Ein Künstler darf nicht für sich selbst voten.
         */
        if(v.equals(k)) {
            throw new InvalidVoteException();
        }
        votes.add(new Vote(v, k, scoreString));
    }
}