import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

import org.junit.Before;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Rule
    public ExpectedException exception = ExpectedException.none();

    Veranstaltung veranstaltung;
    Kuenstler hubert;
    Kuenstler gabi;
    Kuenstler ida;
    Kuenstler sarah;
    Kuenstler thomas;

    @Before
    public void setUp() {
        veranstaltung = new Veranstaltung(3);
        hubert = new Kuenstler("Hubert", 23);
        gabi = new Kuenstler("Gabi", 33);
        ida = new Kuenstler("Ida", 75);
        sarah = new Kuenstler("Sarah", 75);
        thomas = new Kuenstler("Thomas", 53);

        try {
			veranstaltung.teilnehmen(hubert);
	        veranstaltung.teilnehmen(gabi);
	        veranstaltung.teilnehmen(ida);
		} catch (InvalidCandidateException e) {
			fail("Unexpected InvalidCandidateException thrown: "+e.getMessage());
		}
    }

    @Test
    public void testInvalidCandidate() throws Exception {
        veranstaltung.vote(hubert, gabi, "1:20%");
        assertEquals(veranstaltung.points(gabi), 1.0, 0.01);
        veranstaltung.vote(ida, gabi, "1:50%,2:50%");
        assertEquals(veranstaltung.points(gabi), 6.0, 0.01);
        exception.expect(InvalidCandidateException.class);
        veranstaltung.vote(hubert, thomas, "3:50%"); // kein Teilnehmer
    }

    @Test
    public void testInvalidVote1() throws Exception {
        veranstaltung.vote(hubert, gabi, "1:50%");
        assertEquals(veranstaltung.points(gabi), 2.5, 0.01);
        veranstaltung.vote(ida, gabi, "1:50%,2:50%");
        assertEquals(veranstaltung.points(gabi), 7.5, 0.01);
        exception.expect(InvalidVoteException.class);
        veranstaltung.vote(hubert, gabi, "3:50%"); // doppelt gevoted
    }

    @Test
    public void testInvalidVote2() throws Exception {
        veranstaltung.vote(thomas, gabi, "1:20%");
        assertEquals(veranstaltung.points(gabi), 1, 0.01);
        veranstaltung.vote(thomas, ida, "1:20%");
        assertEquals(veranstaltung.points(ida), 1, 0.01);
        veranstaltung.vote(thomas, hubert, "1:20%");
        assertEquals(veranstaltung.points(hubert), 1, 0.01);
        exception.expect(InvalidVoteException.class);
        veranstaltung.vote(hubert, hubert, "3:50%"); // self-vote
    }
}
