
/*
   Aufgabe5) Dynamisches Binden, final und Exception-Handling

    Achtung! Die mitgelieferten Unit Tests testen nur einen kleinen Teil der Funktionalität ab.
     Bei minimalen, falschen (unnötige Setter, Sichtbarkeit, keine Fehlerbehandlung, equals, hashCode, kein final)
     oder unkommentierten (!) Lösungen wird das Kreuzerl aberkannt.
     Bei fortgeschrittenen Gruppen wird die Toleranzgrenze geringer sein.
     Sie können aber nicht mehr verlieren als das Kreuzerl nicht zu bekommen, d.h. Sie sollten es versuchen!


   Beschreibung

    Implementieren Sie die Klasse Kleiderschrank mit folgenden Eigenschaften:
    - Bezeichnung
    - Besitzer
    - Fassungsvermögen
    - Liste aller Kleidungsstuecke in diesem Kleiderschrank (Im Kleiderschrank
      können maximal so viele Kleidungsstuecke liegen, wie es das Fassungsvermögen
      vorgibt. Er kann auch leer sein.)

    Abgesehen von der Liste an Kleidungsstuecken müssen alle Eigenschaften im
    Konstruktor festgelegt werden. Diese müssen nicht von außen zugreifbar sein.

    Implementieren Sie das Interface Kleidungsstueck mit folgenden Eigenschaften:
    - Bezeichnung
    - Farbe
    - Shop
    - ArtikelNr
    - Konfektion (String)

    Implementieren Sie die Klasse Hose. Diese Klasse implementiert Kleidungsstueck.
    Sie hat zusätzlich folgende Eigenschaften:
    - Eignung: einzig Zulässige Werte: maennlich, weiblich, unisex
    - Konfektion: Wenn Eignung männlich oder unisex, einzig Zulässige Werte:
      Ganze Zahlen von 44 bis 56
      Wenn Eignung weiblich, einzig zulässige Werte: Ganze Zahlen von 32 bis 46

    Implementieren Sie die Klasse Oberteil. Diese Klasse implementiert Kleidungsstueck
    - Konfektion: einzig zulässige Werte: XXS, XS, S, M, L, XL, XXL, XXXL

    Implementieren Sie die Klasse Kleid. Diese Klasse implementiert Kleidungsstueck.
    Sie hat zusätzlich folgende Eigenschaften:
    - Konfektion: Einzig zulässige Werte: Ganze Zahlen von 32 bis 46

    Alle Eigenschaften von den Klassen Hose, Oberteil und Kleid müssen in den jeweiligen
    Konstruktoren festgelegt werden.

    Stellen Sie sicher, dass die Ausgabe eines Objekts vom Typ Kleiderschrank
    mittels System.out.println(...) folgende Beschreibung des Kleiderschranks
    liefert:
    # Kleiderschrank <Bezeichnung> von <Besitzer>, Gesammtes Fassungsvermögen:
    <Fassungsvermögen>, Anzahl der noch aufnehmbaren Kleidungsstuecke:
    <Fassungsvermögen Minus Anzahl der vorhandenen Kleidungsstuecke>, Inhalt:
    # <pro Zeile: Aufruf der toString Methoden aller Kleidungsstuecke in diesem
    Kleiderschrank>

    Stellen Sie sicher, dass die Ausgabe eines Objektes, das Kleidungsstueck
    implementiert den Typ seiner zugehörigen Klasse
    und alle seine Eigenschaften liefert. Z.b.:
    # Hose: Weite Jogginghose, Blau, Hervis, PUM4-123, unisex, 44

    Wichtig: Innerhalb der Liste der Kleidungsstuecke in einem Kleiderschrank
    darf es keine zwei gleichen Objekte geben. Zwei Kleidungsstuecke sind
    gleich, wenn ihre Kombination aus Shop und ArtikelNr gleich sind.

    Funktionalität und Fehlerbehandlung:

    - Beim Versuch ein neues Kleidungsstück über die Methode add(Kleidungsstueck k)
      in den Kleiderschrank aufzunehmen, soll zuerst mit Hilfe der Methode
      search(Kleidungsstueck k) überprüft werden, ob das Kleidungsstück schon vorhanden ist.
      Wenn das Kleidungsstück schon im Kleiderschrank vorkommt, soll eine
      DuplicateClothException geworfen werden, die eine sinnvolle Meldung beinhaltet.
    - Der Kleiderschrank soll eine Methode hatFreienPlatz() besitzen, die
      einen boolean Wert zurückliefert, der true zurückgibt, wenn der
      Kleiderschrank noch Kapazitäten hat und false, wenn er schon bis zur
      Kapazitätsgränze befüllt ist. Rufen Sie diese Methode vor dem Versuch neue
      Kleidungsstuecke in den Kleiderschrank einzufüllen auf.
    - Beim Versuch mehr Kleidungsstuecke in den Kleiderschrank aufzunehmen als
      die Kapazität des Kleiderschranks erlaubt, soll eine
      WardrobeOutOfBoundException geworfen werden, die eine sinnvolle Meldung
      beinhaltet.
    - Beim Versuch eine Konfektionsgröße anzugeben, die die oberen Bedingungen
      verletzt, soll eine InvalidClothSizeException geworfen werden, die angibt,
      warum die Kleidergröße nicht zulässig ist.
    - Beim Versuch für die Variable Konfektionsgröße einen String zu übergeben,
      der keine ganze Zahl beinhält, soll in den Klassen Kleid und Hose eine
      NumberFormatException geworfen werden.


    Implementieren Sie die oben angegebenen eigenen Exception Typen:
    DuplicateClothException,
    WardrobeOutOfBoundException, (muss von IndexOutOfBoundsException abgeleitet sein)
    InvalidClothSizeException

     Zusatzfragen:
    - Was versteht man unter "Typinformation" und "Typauflösung"?
    - Was ist der unterschied zwischen statischem und dynamischem Binden? Zu
      welchem Zeitpunkt werden Funktions- und Variablennamen jeweils aufgelöst?
    - Welchen Vorteil bringt dynamisches Binden im oberen Beispiel?
    - Werden in Java private, static und final methoden mit Hilfe von
      statischem oder dynamischem Binden aufgelöst?
*/
public class Aufgabe5 {

    static Kleiderschrank erstelleKleiderschrank(String bezeichnung, String besitzer, int fassungsvermoegen) {
        Kleiderschrank habnichtszumanziehen = new Kleiderschrank(bezeichnung,besitzer,fassungsvermoegen);
        return habnichtszumanziehen;
    }

    static Kleidungsstueck kaufeHose(String eignung, String konfektion) {
        // TODO: Create and return Hose

        Kleidungsstueck h =null;
        try{
             h= new Hose("Weite Jogginghose","Blau","Hervis","PUM4-123",eignung,konfektion);

        }catch(InvalidClothSizeException size){

        }

        return h;
    }

    // just for testing ...
    public static void main(String[] args) {
        // Implementierung von main wird nicht beurteilt
        //System.out.println(kaufeHose("unisex","44"));
        Kleiderschrank ks = Aufgabe5.erstelleKleiderschrank("Platz", "Sandra", 1);
        Kleidungsstueck hose = Aufgabe5.kaufeHose("weiblich", "32");
        System.out.println(ks.toString());
        ks.add(hose);
        System.out.println(ks.getPlatz());
        System.out.println(ks.toString());



    }
}