/**
 * Created by July on 13.06.2015.
 *
 * Diese Klasse repraesentiert ein Kleid. Objekte davon werden in der Klasse Kleiderschrank erstellt und gespeichert.
 *
 */
public final class Kleid implements Kleidungsstueck {
    private final String bezeichnung;
    private final String konfektion;
    private String farbe;
    private final String shop;
    private final String nr; //Artikelnummer

    /*
     * Wird der Variable konfektion keine ganze Zahl als String uebergeben, wird eine NumberFormatException geworfen.
     * Ist die Zahl im String von konfektion nicht zwischen 32 und 46, wird eine InvalidClothSizeException geworfen.
     */

    public Kleid(String bezeichnung, String konfektion, String farbe, String shop, String nr )throws InvalidClothSizeException, NumberFormatException{

        try{
            int i = Integer.parseInt(konfektion);
        }catch(NumberFormatException n){
            System.out.println("Konfektion ist keine ganze Zahl");
        }

        if(!(Integer.parseInt(konfektion) >=32 && Integer.parseInt(konfektion) <=46)) {
            throw new InvalidClothSizeException("Unzulässige Groesse! Nur Konfektionsgroessen zwischen 32 und 46 erlaubt!");
        }
        this.bezeichnung = bezeichnung;
        this.konfektion = konfektion;
        this.farbe = farbe;
        this.shop = shop;
        this.nr = nr;

    }
    @Override
    public String bezeichnung() {
        return this.bezeichnung;
    }

    @Override
    public String farbe() {
        return this.farbe;
    }

    @Override
    public String shop() {
        return this.shop;
    }

    @Override
    public String articleNr() {
        return this.nr;
    }

    @Override
    public String konfektion() {
        return this.nr;
    }

    /*
     * liefert einen String z.B in folgender Form zureuck:
     * Kleid: Cocktailkleid, Schwarz, Vera Moda, VM-123, weiblich, 38"
     */
    public String toString(){
        return "Kleid: " + this.bezeichnung + ", "+ this.farbe + ", "+ this.shop+ ", "+this.nr+ ", "+this.konfektion;
    }
    public int hashCode(){
        return this.shop.hashCode() +this.nr.hashCode();
    }

    public boolean equals(Object o){
        if(! (o instanceof Kleid)){
            return false;
        }
        if(o==null )
            return false;

        if( this.getClass()==o.getClass()){
            Kleid that=(Kleid)o;
            return this.hashCode() == that.hashCode() &&this.shop().equals(that.shop) &&this.articleNr().equals(that.articleNr());

        }else{
            return false;
        }
    }
}
