import java.util.ArrayList;
import java.util.List;



/*
 * Diese Klasse repraesentiert einen Kleiderschrank der Kleidungsstuecke in einer Liste speichert.
 * Ein Kleiderschrank hat eine Bezeichnung, einen Besitzer und eine Größe die angibt, wieviele Kleidungsstuecke
 * gespeichert werden koennen.
 */
public final class Kleiderschrank {

    // TODO: comment+implement
    private String bez;
    private String besitzer;
    private int size;
    private List<Kleidungsstueck> kleiderstange = new ArrayList<Kleidungsstueck>();

    public Kleiderschrank(String bez, String besitzer, int size){
        this.bez = bez;
        this.besitzer = besitzer;
        this.size = size;
    }

    /*
     * Fügt ein Kleidungsstueck der Liste hinzu.
     * Ist das Kleidungsstueck schon vorhanden, wird eine DuplicateClothException geworfen.
     * Ist der Kleiderschrank voll, wird eine WardrobeOutOfBoundException geworfen.
     */
    public void add(Kleidungsstueck ks )throws WardrobeOutOfBoundException, DuplicateClothException {

       if(hatFreienPlatz()){
           if(search(ks)){
               throw new DuplicateClothException("Kleid schon vorhanden");
           }else{
               kleiderstange.add(ks);
           }
       }else{
           throw new WardrobeOutOfBoundException("Kleiderschrank zu voll");
       }


    }

    /*Gibt den freien Platz im Kleiderschrank zureuck, der noch zur Verfuegung steht.
     */
    public int getPlatz(){
        return this.size -kleiderstange.size();
    }

    /*Liefert einen String mit dem Kleiderschrank, und anschließend mit den enthaltenen Kleidungsstuecken.
     Beispiel: Kleiderschrank Platz von Sandra, Gesammtes Fassungsvermögen: 1, Anzahl der noch aufnehmbaren Kleidungsstuecke: 1, Inhalt:
                Hose: Weite Jogginghose, Blau, Hervis, PUM4-123, unisex, 44
     */
    public String toString(){
        String s="";
        s+="Kleiderschrank " +this.bez+" von "+ this.besitzer+ ", " +"Gesammtes Fassungsvermögen: " + this.size +", Anzahl der noch aufnehmbaren Kleidungsstuecke: " + getPlatz()+", Inhalt:";

        for(Kleidungsstueck k:kleiderstange){
            s+='\n';
            s+=k.toString();
        }
        return s;
    }
    /*
    Liefert true, wenn noch freier Platz im Kleiderchrank ist. Ansonsten false.
     */
    public boolean hatFreienPlatz(){
        if(getPlatz() >0){
            return true;
        }else{
            return false;
        }
    }


    /*
    Liefert true, wenn das Kleidungsstueck gefunden wurde, ansonsten false;
     */
    public boolean search(Kleidungsstueck k){
        for(Kleidungsstueck a:kleiderstange){

            if(a.equals(k)){
                return true;

            }else{
                return false;
            }
        }
        return false;
    }


}
