/**
 * Created by July on 13.06.2015.
 *
 * Diese Klasse repraesentiert ein Oberteil. Objekte davon werden in der Klasse Kleiderschrank erstellt und gespeichert.
 */
public class Oberteil implements Kleidungsstueck{

    private final String bezeichnung;
    private final String konfektion;
    private String farbe;
    private final String shop;
    private final String nr;
    private final static String kgroessen="XXS, XS, S, M, L, XL, XXL, XXXL";

    /*
     * Wird bei der Variable konfektion etwas anderes als die Werte in kgroessen uebergeben, ist das eine unzulaessige Groesse
     * und es wird eine InvalidClothSizeException geworfen.
     */
    public Oberteil(String bezeichnung, String konfektion, String farbe, String shop, String nr)throws InvalidClothSizeException{
        if(!kgroessen.contains(konfektion)){
            throw new InvalidClothSizeException("Unzulaessige Groesse!");
        }
        this.bezeichnung = bezeichnung;
        this.konfektion = konfektion;
        this.farbe = farbe;
        this.shop = shop;
        this.nr =nr;

    }
    @Override
    public String bezeichnung() {
        return this.bezeichnung;
    }

    @Override
    public String farbe() {
        return this.farbe;
    }

    @Override
    public String shop() {
        return this.shop;
    }

    @Override
    public String articleNr() {
        return this.shop;
    }

    @Override
    public String konfektion() {
        return this.konfektion;
    }

    public String toString(){
        return "Oberteil: " + this.bezeichnung + ", "+ this.farbe + ", "+ this.shop+ ", "+this.nr+ ", "+this.konfektion;
    }


    public int hashCode(){
        return this.shop.hashCode() +this.nr.hashCode();
    }

    public boolean equals(Object o){
        if(! (o instanceof Oberteil)){
            return false;
        }
        if(o==null )
            return false;

        if( this.getClass()==o.getClass()){
            Oberteil that=(Oberteil)o;
            return this.hashCode() == that.hashCode() &&this.shop().equals(that.shop) &&this.articleNr().equals(that.articleNr());

        }else{
            return false;
        }
    }
}
